unit ICRGBColourWhats;

interface

	uses
		ICWindowGlobals;

	function WhatOpenRGBColour (wt: WindowType; item: integer): OSErr;
	function WhatClickRGBColour (wt: WindowType; item: integer; er: eventRecord): OSErr;
	function WhatFlushRGBColour (wt: WindowType; item: integer): OSErr;
	function WhatCloseRGBColour (wt: WindowType; item: integer): OSErr;

implementation

	uses
		ColorPicker,
		
		ICAPI,
		ICSubs,
		ICDialogs,
		ICDocument,
		ICMiscSubs,
		ICGlobals;

	procedure DrawRGBSampleProc (window: DialogPtr; item: integer);
		var
			colour_ptr : RGBColorPtr;
			old_colour : RGBColor;
			old_ps : PenState;
			r : Rect;
			wt : WindowType;
	begin
		wt := GetWindowType(window);
		GetPenState(old_ps);
		PenNormal;
		GetDItemRect(window, item, r);
		FrameRect(r);
		colour_ptr := RGBColorPtr(windowinfo[wt].items[item + 1]^.data);
		if colour_ptr <> nil then begin
			GetForeColor(old_colour);
			RGBForeColor(colour_ptr^);
			InsetRect(r, 3, 3);
			PaintRect(r);
			RGBForeColor(old_colour);
		end; (* if *)
		SetPenState(old_ps)
	end; (* DrawRGBSampleProc *)

	function WhatOpenRGBColour (wt: WindowType; item: integer): OSErr;
		var
			colour : RGBColor;
			attr : ICAttr;
			size : longint;
	begin
		SetDItemHandle(windowinfo[wt].window, item - 1, @DrawRGBSampleProc);

		size := sizeof(RGBColor);
		if ICGetPref(GetInstance, windowinfo[wt].items[item]^.key, attr, @colour, size) <> noErr then begin
			colour.red := -1;			(* Pascal defines RGBColor using signed fields, duh!, so -1 = $FFFF = white *)
			colour.green := -1;
			colour.blue := -1;
		end; (* if *)
		ProcessAttributes(wt, item, attr);
		
		if has_colorQD then begin
			windowinfo[wt].items[item]^.data := NewPtr(sizeof(RGBColor));
			if windowinfo[wt].items[item]^.data <> nil then begin
				RGBColorPtr(windowinfo[wt].items[item]^.data)^ := colour;
			end; (* if *)
		end else begin
			windowinfo[wt].items[item]^.data := nil;
			SetDCtlEnable(windowinfo[wt].window, item, false);
		end; (* if *)
		
		if IsLocked(wt, item) then begin
			SetDCtlEnable(windowinfo[wt].window, item, false);
		end; (* if *)
		
		windowinfo[wt].items[item]^.modified := false;
		
		WhatOpenRGBColour := noErr;
	end; (* WhatOpenRGBColour *)
	
	function WhatClickRGBColour (wt: WindowType; item: integer; er: eventRecord): OSErr;
		var
			colour_ptr : RGBColorPtr;
			new_colour : RGBColor;
	begin
		{$unused er}
		colour_ptr := RGBColorPtr(windowinfo[wt].items[item]^.data);
		if colour_ptr <> nil then begin
			if GetColor(Point(0), GetAString(128, 27), colour_ptr^, new_colour) then begin
				colour_ptr^ := new_colour;
				InvalDItem(windowinfo[wt].window, item - 1);
				windowinfo[wt].items[item]^.modified := true;
				DirtyDocument;
			end; (* if *)
		end; (* if *)
		WhatClickRGBColour := noErr;
	end; (* WhatClickRGBColour *)
	
	function WhatFlushRGBColour (wt: WindowType; item: integer): OSErr;
		var
			err : OSErr;
			colour_ptr : RGBColorPtr;
	begin
		err := noErr;
		colour_ptr := RGBColorPtr(windowinfo[wt].items[item]^.data);
		if (colour_ptr <> nil) & (windowinfo[wt].items[item]^.modified) then begin
			err := ICMapErr(ICSetPref(GetInstance, windowinfo[wt].items[item]^.key, ICattr_no_change, Ptr(colour_ptr), sizeof(RGBColor)));
			windowinfo[wt].items[item]^.modified := false;
		end; (* if *)
		WhatFlushRGBColour := err;
	end; (* WhatFlushRGBColour *)

	function WhatCloseRGBColour (wt: WindowType; item: integer): OSErr;
	begin
		if windowinfo[wt].items[item]^.data <> nil then begin
			DisposePtr(windowinfo[wt].items[item]^.data);
			windowinfo[wt].items[item]^.data := nil;
		end; (* if *)
		WhatCloseRGBColour := noErr;
	end; (* WhatCloseRGBColour *)

end. (* ICRGBColourWhats *)
